package program;

import java.awt.Image;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.Icon;
import javax.swing.ImageIcon;

import program.utilities.IORead_Stats;


/*
 *   LICENSE
 * 
 *   wiki2xhtml is thought to be an effective and efficient way to create
 *   complete webpages from wikitext files.
 *   Copyright (C) 2008  Simon A. Eugster
 *                       Ob. Waldhofstr. 14
 *                       CH-9240 Uzwil

 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.

 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.

 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

/**
 * Resources from the jar file itself
 * 
 * @author 	Simon A. Eugster, hb9eia
 * ,		CH-9240 Uzwil
 * ,		simon.eu@gmail.com
 */
public class Container_Resources {
	
	private Container_Resources() { }
	private static Container_Resources cr = new Container_Resources();
	
	/** Singleton */
	public static Container_Resources getInstance() { return cr; }

	public final Icon rAdd = new ImageIcon(getClass().getResource(
			"/resources/add.png"));

	public final Icon rOpen = new ImageIcon(getClass().getResource(
			"/resources/open.png"));

	public final Icon rMOpen = new ImageIcon(getClass().getResource(
			"/resources/mopen.png"));

	public final Icon rClose = new ImageIcon(getClass().getResource(
			"/resources/close.png"));

	public final Icon rAbout = new ImageIcon(getClass().getResource(
			"/resources/about.png"));

	public final Icon rHelp = new ImageIcon(getClass().getResource(
			"/resources/help.png"));

	public final Icon rNext = new ImageIcon(getClass().getResource(
			"/resources/next.png"));

	public final Icon rSwiss = new ImageIcon(getClass().getResource(
			"/resources/swiss.png"));
	
	public final Icon rGermany = new ImageIcon(getClass().getResource(
			"/resources/germany.png"));

	public final Icon rDir = new ImageIcon(getClass().getResource(
			"/resources/dir.png"));
	
	public final Icon rDirOpen = new ImageIcon(getClass().getResource(
	"/resources/dirOpen.png"));
	
	public final Icon rSave = new ImageIcon(getClass().getResource(
	"/resources/save.png"));

	public final Icon rSaveDisk = new ImageIcon(getClass().getResource(
			"/resources/saveDisk.png"));
	
	public final Icon rExportSh = new ImageIcon(getClass().getResource(
	"/resources/export-sh.png"));
	
	public final Icon rExportBat = new ImageIcon(getClass().getResource(
	"/resources/export-bat.png"));
	
	public final File rPDF = new File(getClass().getResource("/resources/pdf-200px.png").getFile());
	public final File rPDFCrystal = new File(getClass().getResource("/resources/Crystal_Clear_mimetype_pdf.png").getFile());
	public final File rOOo = new File(getClass().getResource("/resources/Crystal_Clear_app_openoffice.png").getFile());
	
	public static final String 
		spicture = "/resources/picture.html", 
		spictureT = "/resources/pictureT.html", 
		sthumbPicture = "/resources/thumbPicture.html",
		sthumbPictureT = "/resources/thumbPictureT.html", 
		sgalleryText = "/resources/galleryText.html",
		sgalleryImageNodesc = "/resources/galleryImageNodesc.html",
		sgalleryImage = "/resources/galleryImage.html",
		sgalleryContainer = "/resources/galleryContainer.html",
		sabout = "/resources/about.html",
		smissingTemplate = "/resources/tplMissingTemplate.txt";;
	
	public static final java.net.URL uabout = Container_Resources.class.getResource("/resources/gui-about.html");
	public static final java.net.URL uhelp = Container_Resources.class.getResource("/resources/gui-help.html");
	
	public final Image getIcon() {
		try {
			return ImageIO.read(getClass().getResource("/resources/wx-icon.png"));
		} catch (IOException e) {
			
			e.printStackTrace();
			return null;
		}
	}
	
	public static StringBuffer readResource(String s) {
		return IORead_Stats.readFromJar(s);
	}
	
}
