package program.guiWindows;

import javax.swing.JTextField;

import org.xnap.commons.i18n.I18n;
import org.xnap.commons.i18n.I18nFactory;

import program.Container_Files;
import program.commentator.CommentAtor;
import program.utilities.IOUtils;

/*
 *   LICENSE
 * 
 *   wiki2xhtml is thought to be an effective and efficient way to create
 *   complete webpages from wikitext files.
 *   Copyright (C) 2008  Simon A. Eugster
 *                       Ob. Waldhofstr. 14
 *                       CH-9240 Uzwil

 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.

 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.

 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

/**
 * This is a class.
 * 
 * @author 	Simon A. Eugster, hb9eia
 * ,		CH-9240 Uzwil
 * ,		simon.eu@gmail.com
 */
public final class GuiFunctions {
	
	private static final I18n i18n = I18nFactory.getI18n(GuiFunctions.class, "bin.l10n.Messages", program.Globals.getLocale());
	private static final CommentAtor ca = CommentAtor.getInstance();
	
	private static final String className = "GuiFunctions";

	
	public static void targetDir(JTextField jtfTargetDir) {

		if (Container_Files.getInstance().setTargetDirectory(jtfTargetDir.getText())) {
			if (IOUtils.fileExists(jtfTargetDir.getText()))
				ca.ol(className
						+ i18n.tr("(Existing) Target directory set: ")
						+ Container_Files.getInstance().cont.targetDir().getPath(), CommentAtor.V_MSG);
			else
				ca.ol(className
						+ i18n.tr("(New) Target directory set: ")
						+ Container_Files.getInstance().cont.targetDir().getPath(), CommentAtor.V_MSG);
		} else
			System.out.println(className + "Strange ...");
	}

}
