package program.tools;

import java.io.File;
import java.io.IOException;

import program.Args;
import program.Constants;
import program.Handler_Arguments;
import program.Container_Files;
import program.commentator.Logger;
import program.utilities.IORead_Stats;
import program.utilities.IOUtils;
import program.utilities.IOWrite_Stats;


/*
 *   LICENSE
 * 
 *   wiki2xhtml is thought to be an effective and efficient way to create
 *   complete webpages from wikitext files.
 *   Copyright (C) 2008  Simon A. Eugster
 *                       Ob. Waldhofstr. 14
 *                       CH-9240 Uzwil

 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.

 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.

 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

/**
 * Read/write config/script files files
 * 
 * @author 	Simon A. Eugster, hb9eia
 * ,		CH-9240 Uzwil
 * ,		simon.eu@gmail.com
 */
public class ScriptExport {


	
	/**
	 * Writes various files (settings and scripts) 
	 * 
	 * @param filetype - The filetype. Possible is .wx, .sh and .bat.
	 */
	public static void writeFile(String filetype) {
		StringBuffer arguments = Container_Files.getInstance().getAllArguments().getArgs().append(Container_Files.getInstance().getFileList().getArgs());
		if ("wx".equals( filetype )) {
			File f = IOUtils.openOutFileDialog("wx", new File(Constants.Directories.workingDir), null, true);
			if (f != null && !f.isDirectory()) {
				try {
					IOWrite_Stats.writeString(f, arguments.toString(), false);
				} catch (IOException e) {
					Logger.getInstance().log.append(e);
					e.printStackTrace();
				}
			}
			
		} else if ("sh".equals( filetype ) || "bat".equals( filetype )) {
			File f = IOUtils.openOutFileDialog(filetype, new File(Constants.Directories.workingDir), null, true);
			String shell = ("sh".equals(filetype) ? "#!/bin/sh\n" : "");
			if (f != null && !f.isDirectory()) {
				try {
					IOWrite_Stats.writeString(f, shell + "java -jar wiki2xhtml.jar " + arguments, false);
				} catch (IOException e) {
					Logger.getInstance().log.append(e);
					e.printStackTrace();
				}
			}
		}
	}
	

	
	public static void readFile() {
		File f = IOUtils.openInFileDialog("wx", new File(Constants.Directories.workingDir), null, false);
		if (f != null && f.exists() && f.canRead() && f.isFile()) {
			System.out.println(f.getPath());
			StringBuffer args = new StringBuffer();
			try {
				args = IORead_Stats.readSBuffer(f);
			} catch (IOException e) {
				Logger.getInstance().log.append(e);
				e.printStackTrace();
			}
			
			Handler_Arguments.handleCommandLineArguments(new Args(Handler_Arguments.handleReplaceArguments(args.toString())), false);
		}
	}
}
